clear a b; tic;

realevals = flipud(sort(eig(r)));

variables = size(r,1);  % number of variables.

for a = 1:Ndatsets;evals(:,a) = svd(corrcoef(randn(cases,variables)));;end
means = (mean(evals,2));   % mean eigenvalues for each position.
evals = sort(evals,2);     % sorting the eigenvalues for each position.
percentiles = (evals(:,round((percent*Ndatsets)/100)));  % percentiles.

%nfactors = 0;
for root = 1:variables;
if realevals(root,1) < percentiles(root,1) 
nfPARPCA = root - 1;
break;end;end;
	

clear evals

%disp(['   Parallel Analysis ']); disp([' '])
%disp(['Variables  = ' num2str(variables) ]);
%disp(['Cases      = ' num2str(cases) ]);
%disp(['Ndatsets     = ' num2str(Ndatsets) ]);
%disp(['Percentile = ' num2str(percent) ]); disp([' '])
%disp(['     Root'  '     Means'  '     Percent' '    Eigen' ])
%disp([(1:variables).'  means percentiles realevals])
%disp(['Parallel Analysis: Number of Factors =  '  num2str(nfPAR) ]);; disp([' '])
%disp(['time for this problem = ', num2str(toc) ]); disp([' '])
		
		
