% Velicer's MAP test;

nvars = size(r,1);
[eigvect,eigval,v] = svd(r);
loadings = eigvect * sqrt(eigval);

fm = [(1:nvars); (1:nvars)]';
fm(1,2) = (sum(sum(r.^2))-nvars)/(nvars*(nvars-1));
for m = 1:nvars - 1;
a = loadings(:,1:m);
partcov = r - (a * a');
d = diag (  (1 ./ sqrt(diag(partcov)))   , 0);
pr = d * partcov * d;
fm(m+1,2) = (sum(sum(pr.^2))-nvars)/(nvars*(nvars-1));
end;

% identifying the smallest fm value & its location
minfm = fm(1,2);
nfVEL = 0;
for s = 1:nvars;
fm(s,1) = s - 1;
if  fm(s,2) < minfm ;
minfm = fm(s,2);
nfVEL = s - 1;
end; end;

%disp(['Velicers Minimum Average Partial Test ']); disp([' '])
%disp(['   Eigenvalues ']);
%disp([diag(eigval)]); disp([' '])
%disp(['Velicers Average Squared Correlations']);
%disp([fm]);
%disp(['The smallest average squared correlation is   ' num2str(minfm)]); disp([' '])
%disp(['MAP Test: Number of Factors =   ' num2str(nfactorsVEL)]); disp([' '])









