

% Image Factor Extraction (Gorsuch 1983 p 113), Velicer (1974, Educ & Psych Meas, 34, p 564)

d =  diag( 1 ./ diag(inv(r)) );

gvv = r + d * inv(r) * d - 2 * d;

r = gvv;

% factor pattern for image analysis Velicer 1974 p 565 formula (2)

s = sqrt(d);                     %  Velicer 1974 p 565 formula (7)

r2 = inv(s) *  gvv  * inv(s);    %  Velicer 1974 p 565 formula (5)

[eigvect,eigval] = eig(r2);

eigval = diag(eigval);

l = eigvect(:,1:nfactors);

dd = sqrt(diag( (eigval(1:nfactors,:)), 0 ));

lding = s * l * dd;                   %  Velicer 1974 p 565 formula (2)



