% Maximum likelihood Factor analysis algorithm -- Marcus, 1993

% enter r matrix into  Rho
% specify number of factors (k)

Rho = r;

% specify number of factors
k=nfactors;

[p,p]=size(Rho);
[A,L,A]=svd(Rho);  % preliminary singular value decomposition of Rho
A1=A(:,1:k)*sqrt(L(1:k,1:k));   % Prin. Comp. loadings
Uni=diag(diag(Rho-A1*A1'));     % Uniqueness matrix
Rh1=sqrt(inv(Uni))*(Rho-Uni)*sqrt(inv(Uni)); % Matrix to iterate
[A,L,A]=svd(Rh1);  % First estimate of Maximum Likelihood Loadings
A1=sqrt(Uni)*A(:,1:k)*sqrt(L(1:k,1:k));


check=tolerml;
for i=1:iterml
   Uni=diag(diag(Rho-A1*A1'));
   Rh1=sqrt(inv(Uni))*(Rho-Uni)*sqrt(inv(Uni));
   [A,L,A]=svd(Rh1);
   A2=sqrt(Uni)*A(:,1:k)*sqrt(L(1:k,1:k));
   if max(max(abs(A1-A2)))<check;break;end
   A1=A2;
end


i;  % iterations

A1;  % pattern matrix

FacVar=diag(A1'*A1);

Com=diag(A1*A1');  % communalities

Uniq=ones(p,1)-Com;

Resid=Rho-A1*A1';

lding = A1;

